Global ENetMsg$, ENetOffset

Global Databank = CreateBank( 1024*1024 )
Global Packetlength = CreateBank( 4 )
Global PeerID = CreateBank( 4 )
Global Calculationbank = CreateBank( 4 )

Const ENET_EVENT_TYPE_NONE       = 0
Const ENET_EVENT_TYPE_CONNECT    = 1
Const ENET_EVENT_TYPE_DISCONNECT = 2
Const ENET_EVENT_TYPE_RECEIVE    = 3

Function WriteIntEx( Integer )
	ENetMsg$ = ENetMsg$ + Chr$( Integer And $FF )
	ENetMsg$ = ENetMsg$ + Chr$( ( Integer Shr 8 ) And $FF )
	ENetMsg$ = ENetMsg$ + Chr$( ( Integer Shr 16 ) And $FF )
	ENetMsg$ = ENetMsg$ + Chr$( Integer Shr 24 )
End Function

Function WriteByteEx( Byte )
	ENetMsg$ = ENetMsg$ + Chr$( Byte )
End Function

Function WriteStringEx( SourceString$ )
	;ENetMsg$ = ENetMsg$ + Chr$( Len( SourceString$ ) )
	WriteIntEx( Len( SourceString$ ) )
	ENetMsg$ = ENetMsg$ + SourceString$
End Function

Function WriteFloatEx( SourceFloat# )
	PokeFloat Calculationbank, 0, SourceFloat#
	ENetMsg$ = ENetMsg$ + Chr$( PeekByte( Calculationbank, 0 ) )
	ENetMsg$ = ENetMsg$ + Chr$( PeekByte( Calculationbank, 1 ) )
	ENetMsg$ = ENetMsg$ + Chr$( PeekByte( Calculationbank, 2 ) )
	ENetMsg$ = ENetMsg$ + Chr$( PeekByte( Calculationbank, 3 ) )
	PokeFloat Calculationbank, 0, 0
End Function

Function WriteShortEx( Short )
	ENetMsg$ = ENetMsg$ + Chr( Short And $FF )
	ENetMsg$ = ENetMsg$ + Chr( Short Shr 8 )
End Function

Function ReadIntEx()
	Result = PeekInt( Databank, ENetOffset )
	ENetOffset = ENetOffset + 4
	Return Result
End Function

Function ReadByteEx()
	Result = PeekByte( DataBank, ENetOffset )
	ENetOffset = ENetOffset + 1
	Return Result
End Function

Function ReadStringEx$()
	Local Result$
	Length = PeekInt( DataBank, ENetOffset )
	
	For i = 1 To Length
		Result$ = Result$ + Chr$( PeekByte( DataBank, ENetOffset + i + 3 ) )
	Next
	ENetOffset = ENetOffset + Length + 4
	
	Return Result$
End Function

Function ReadFloatEx#()
	Result# = PeekFloat( DataBank, ENetOffset )
	ENetOffset = ENetOffset + 4
	Return Result#
End Function

Function ReadShortEx()
	Result = PeekShort( DataBank, ENetOffset )
	ENetOffset = ENetOffset + 2
	Return Result
End Function